<?php
/*******************************************************************************
 *                               aiboard.php
 *                            -------------------
 *   update      : 2004 2 10 ȭ
 *   copyright   : Aminoai.com
 *   email       : aminoai@aminoai.com
 *   description : Խ ü
 ******************************************************************************/

include_once dirname(__FILE__)."/DB_Mysql.php";
include_once dirname(__FILE__)."/AI_Article.php";

class AI_Board
{
	var $id, $table, $index, $page, $num_list, $num_page, $search_value, $search_operator, $sort;
	var $search_only, $total_article, $total_page;
	var $search_item = Array();
	var $option = Array();
	
	function AI_Board($id, $table, $index, $page, $sort="DESC")
	{
		$this->id = $id;
		$this->table = $table;
		$this->index = $index;
		if($page<1) $page=1;
		$this->page = $page;
		$this->sort = $sort;
        
		$this->num_list = 15;
		$this->num_page = 10;
		
		$this->search_value = "";
		$this->search_operator = "or";
		
		return true;
	}
	
	function configBoard($num_list, $num_page)
	{
		if ($num_list<1) $num_list=15;
		if ($num_page<1) $num_page=10;
		$this->num_list = $num_list;
		$this->num_page = $num_page;
		return true;
	}
	
	function configSearch($search, $op="or", $ol=false)
	{
		$this->search_value = $search;
		$this->search_operator = $op;
        $this->search_only = $ol;
        $this->getTotalPage();
	}
	
	function makeList($field)
	{
		$startNum = ($this->page - 1) * $this->num_list;
		$num_list = $this->num_list;
		$where = $this->makeWhere();
		$index = $this->index;
		$table = $this->table;
		
		$sqlField = $this->sqlField($field);
		
		//   ѵ  
		$db = new DB_Mysql();$db->open();
		$sql = "select ".$sqlField." from `".$table."` ".$where." 
			order by `".$index."` ".$this->sort." limit ".$startNum." , ".$num_list.";";
		$db->query($sql);
		$db->close();
		
		$rows = $db->numRows();
		$dbEnd = $startNum + $rows;
		$listEnd = ($startNum + $num_list)-1;
		
		while($startNum<$dbEnd && $startNum<=$listEnd ){
			$db->dataSeek($startNum);
			$data = $db->fetchArray();
			
			$art = new AI_Article();
			for($i=0;$i<count($field);$i++){
				$art->regist($field[$i], $data[$field[$i]]);
			}
			
			$result[] = $art;
			$startNum++;
		}
		
		return $result;
	}
	
	function sqlField($field)
	{
		for($i=0;$i<count($field);$i++){
			if($i!=0) $sqlField .= ", ";
			$sqlField .= $field[$i];
		}
		return $sqlField;
	}
	
	function makeWhere()
	{
		$result = "";
		$a = $this->search_item;
		if ($this->search_value==""){
			return $result;
		}
		$i=0;$j=0;
		foreach($a as $k => $v) {
			if($v["var"]=="yes") {
				if($j==0)$result .= "where ";
				if($i!=0&&$j!=0){
					$op = ($this->search_operator == "or") ? "or" : "and" ; 
					$result .= $op;
				}
                $sv = ($this->search_only) ? $this->search_value : "%".$this->search_value."%" ; 
				$result .= " `".$v["field"]."` like '".$sv."' ";
				$j++;
			}
			$i++;
		}
		return $result;
	}
	
	function pageOrder()
	{
		$URL		= $this->throwOrd();
		$num_page	= $this->num_page;		//ѹ  ȣ 
		$nowNum 	= $this->page;			//  ȣ
		$total_page	= $this->total_page;
        
        
        
		$group = ceil($nowNum / $num_page);
		$endGroup = ceil($total_page / $num_page);
		$groupStart = ( ($group - 1)*$num_page ) + 1;
		$groupEnd  = $group * $num_page ;
		
		if ( $group != 1 ) {
			$ordList .= "<a href=\"".$URL."&page=1\" class=\"ord_link\">[1]</a>";
			$ordList .= "<a href=\"".$URL."&page=".($groupStart - 1)."\" class=\"ord_link\">...</a>";
		}
		for ($i=$groupStart;$i<$groupEnd+1;$i++){
			if ( $i <= $total_page ){
				if ($i==$nowNum) $ordList .= " <span class=\"ord_now\">$i</span> ";
				else $ordList .= "<a href=\"".$URL."&page=$i\" class=\"ord_link\">[$i]</a>";
			}
		}
		if ( $group != $endGroup ) {
			$ordList .= "<a href=\"".$URL."&page=".($groupEnd + 1)."\" class=\"ord_link\">...</a>";
			$ordList .= "<a href=\"".$URL."&page=$total_page\" class=\"ord_link\">[$total_page]</a>";
		}
		
		return $ordList;
	}
	
	function getTotalArticle()
	{
		$db = new DB_Mysql();$db->open();
		$sql = "select count('".$this->index."') from `".$this->table."` ".$this->makeWhere().";";
		$result = $db->simpleQuery($sql);
		if($result==0) $result=1;
		$db->close();
        $this->total_article = $result;
		return $result;
	}
	
	function getTotalPage()
	{
		$totalNum	= $this->getTotalArticle();
		$num_list 	= $this->num_list;
		$total_page =  ceil($totalNum / $num_list);
        $this->total_page = $total_page;
		return $total_page;
	}
	
	function throwGet()
	{
		$result = "id=".$this->id;
		$result .= "&pri=".$this->index;
		$result .= "&page=".$this->page;
		$result .= "&search=".$this->search_value;
		$result .= "&op=".$this->search_operator;
		$result .= $this->getSearchItem("get");
		return $result;
	}
	
	function throwPost()
	{
		$result = "
		<input type=\"Hidden\" name=\"id\" value=\"".$this->id."\">\n
		<input type=\"Hidden\" name=\"pri\" value=\"".$this->index."\">\n
		<input type=\"Hidden\" name=\"page\" value=\"".$this->page."\">\n
		<input type=\"Hidden\" name=\"search\" value=\"".$this->search_value."\">\n
		<input type=\"Hidden\" name=\"op\" value=\"".$this->search_operator."\">\n
		";
		$result .= $this->getSearchItem("post");
		return $result;
	}
	
	function throwSearch()
	{
		$result = "
		<input type=\"Hidden\" name=\"id\" value=\"".$this->id."\">\n
		<input type=\"Hidden\" name=\"pri\" value=\"".$this->index."\">\n
		<input type=\"Hidden\" name=\"op\" value=\"".$this->search_operator."\">\n
		";
		$result .= $this->getSearchItem("post");
		return $result;
	}
	
	function throwOrd()
	{
		$result = "?id=".$this->id;
		$result .= "&pri=".$this->index;
		$result .= "&search=".$this->search_value;
		$result .= "&op=".$this->search_operator;
		$result .= $this->getSearchItem("get");
		$result .= $this->getOption("get");
		return $result;
	}
	
	function setSearchItem($name, $var, $field)
	{
		$this->search_item[$name] = array(
			"var"	=>$var,
			"field"	=>$field,
		);
		return true;
	}
	
	function getSearchItem($mode)
	{
		$a = $this->search_item;
		$result = "";
		foreach($a as $k => $v) {
	    	if($mode=="get"){
				$result .= "&".$k."=".$v["var"];
			} else if ($mode=="post"){
				$result .= "<input type=\"hidden\" name=\"".$k."\" value=\"".$v["var"]."\">\n";
			}
		}
		return $result;
	}
	
	function setOption($name, $var)
	{
		$this->option[$name] = $var;
		return true;
	}
	function getOption($mode)
	{
		$a = $this->option;
		$result = "";
		foreach($a as $k => $v) {
	    	if($mode=="get"){
				$result .= "&".$k."=".$v;
			} else if ($mode=="post"){
				$result .= "<input type=\"hidden\" name=\"".$k."\" value=\"".$v."\">\n";
			}
		}
		return $result;
	}
	
	function getStartNum()
	{
		return ($this->page-1) * $this->num_list;
	}
	
	function getnum_list()
	{
		return $this->num_list;
	}
	
	function getStartList()
	{
		return $this->getTotalArticle() - $this->getStartNum();
	}
	
	/* 
	 * insert -- field   DB 
	 * int insert ()
	 *  ó   ȯ   false
	 */
	function insert($article)
	{
        $artVar = $article->getVar();
		
		$sql = "INSERT INTO `".$this->table."` (";
		$sql .= $article->getSqlField().") VALUES (";
		$i=0;
		foreach($artVar as $k => $v) {
			if($i!=0)$sql .= ", ";$i++;
			$sql .= "'".$v."'";
		}
		$sql .= ");";
		
		$db = new DB_Mysql();$db->open();
		$result = $db->update($sql);
		$db->close();
		
		return $result;
	}
	
	function delete($seq)
	{
		$query = "delete from `".$this->table."` where `".$this->index."`='".$seq."';";
		
		$db = new DB_Mysql();
		$db->open();
		$db->update($query);
		$db->close();
	}
	
	function modify($seq)
	{
		$a = $this->field;
		$query = "update `".$this->table."` set ";
		$i=0;
		foreach($a as $k => $v) {
			if($i!=0)$query .= ", ";$i++;
			$query .= "`".$v."` = '".$this->$k."'";
		}
		$query .= " where `".$this->index."`='".$seq."';";
		
		$db = new DB_Mysql();
		$db->open();
		$db->update($query);
		$db->close();
	}
	
	function addslashes()
	{
		$a = $this->field;
		foreach($a as $k => $v) {
			$this->$k = addslashes($this->$k);
		}
	}
	
	function htmlspecialchars()
	{
		$a = $this->field;
		foreach($a as $k => $v) {
			$this->$k = htmlspecialchars($this->$k);
		}
	}
}
?>
