<?php # Template_ 2.1.4 2003-12-15 <xtac@xtac.net> http://www.xtac.net Freeware
class Template_
{
	var $compile_check=true;
	var $compile_dir  ='';
	var $compile_ext  ='php';
	var $skin         ='';
	var $notice       =false;

	var $template_dir ='';
	var $prefilter    ='';
	var $postfilter   ='';
	var $permission   =0777;
	var $safe_mode    =false;

	var $caching      =false;
	var $cache_dir    ='_cache';
	var $cache_expire =3600;
	
	var $scp_='';
	var $var_=array();
	var $plugin_fld='tpl_plugin';
    
    function Template_($tDir="tpl", $cDir="tpc")
    {
        $this->template_dir = $tDir;
        $this->compile_dir = $cDir; 
    }

	function setCache($fid, $time=1, $rid='', $cid='')
	{
		if (empty($this->tpl_[$fid])||$this->tpl_[$fid][0]==='stt') {
			$this->_exit('Error #3', 'file id <b>'.$fid.'</b> passed to setCached() is not properly defined');
		}
		if ($time<0) unset($this->tpl_[$fid][2]);
		else $this->tpl_[$fid][2]=array($time, $rid, $cid);
	}
	function isCached($fid)
	{
		if (isset($this->_is_cached[$fid])) return $this->_is_cached[$fid];
		if (!$this->caching || !isset($this->tpl_[$fid][2]) || $this->compile_check==='dev') return 0;
		$info=&$this->tpl_[$fid][2];
		$rid=$info[1];
		$cid=$fid.'/'.$this->skin.'/'.$this->tpl_[$fid][1].($info[2]?'/?'.base64_encode(serialize($info[2])):'');
		$path=$this->cache_dir.'/%cache'.$_SERVER['PHP_SELF'].'/'.md5($cid);
		$lock=$path.'.lock';
		$this->_cache_info[$fid]=array('rid'=>$rid, 'cid'=>$cid, 'path'=>$path, 'lock'=>$lock);
		for ($i=1; @file_exists($lock); $i++) {
			if ($i>20 || $i===1&&filemtime($lock)+2<time()) {
				@touch($lock);
				return $this->_is_cached[$fid]=0;
			}
			usleep(100000);
		}
		if ($info[0]===1) $info[0] = $this->cache_expire;
		if (@!is_file($path) or $info[0] && filemtime($path)+$info[0]<time()) return $this->_lock_cache($fid, $lock, 1);
		if ($rid) {
			$rdir1=$this->cache_dir.'/%clear/';
			$rdir2=$this->_get_clear_path($cid);
			if (is_array($rid)) {
				foreach ($rid as $r) if (@!is_file($rdir1.$r.$rdir2)) return $this->_lock_cache($fid, $lock, 1);
			} elseif (@!is_file($rdir1.$rid.$rdir2)) {
				return $this->_lock_cache($fid, $lock, 1);
			}
		}
		$fp=fopen($path, 'rb');
		$cont=fread($fp, filesize($path));
		fclose($fp);
		if (!$B=strpos($cont,'-') or !$H=strpos($cont,'*')) return $this->_lock_cache($fid, $lock);
		$byte=substr($cont, 0, $B);
		$head=substr($cont, $B+1, $H-$B-1);
		$cont=substr($cont, $H+1);
		if ($head!=$cid || strlen($cont)!=$byte) return $this->_lock_cache($fid, $lock);
		$this->_cache_info[$fid]['cont']=$cont;
		return $this->_is_cached[$fid]=1;
	}
	function print_($fid, $sub=0)
	{
		if (!isset($this->tpl_[$fid])) $this->_exit('Error #2', 'template id <b>'.$fid.'</b> is not defined');
		if (empty($this->dir_)) $this->dir_=dirname(__file__).(substr(__file__,0,1)==='/'?'/':'\\');
		$tpl=&$this->tpl_[$fid];
		if ($tpl[0]==='stt') {
			$this->_read_stpl($this->_get_compile_path($tpl[1]));
			return;
		}
		if ($this->isCached($fid)) {
			echo $this->_cache_info[$fid]['cont'];
			return;
		}
		if (isset($this->_is_cached[$fid])) {
			$cache=&$this->_cache_info[$fid];
			ob_start();
		}
		if ($tpl[0]==='tpl') {
			$cpl_path=$this->_get_compile_path($tpl[1]);
			if (isset($this->scope_list[$fid])) $scope=$fid;
			elseif ($S=strrpos($fid,'.')) $scope=substr($fid, 0, $S);
			else $scope='';
			if ($sub) {
				$this->_include_tpl($cpl_path, $scope);
			} else {
				$this->ebase=error_reporting();
				if ($this->notice) {
					error_reporting($this->ebase|E_NOTICE);
					set_error_handler('_template_notice_handler');
					$this->_include_tpl($cpl_path, $scope);
					restore_error_handler();
				} else {
					error_reporting($this->ebase&~E_NOTICE);
					$this->_include_tpl($cpl_path, $scope);
				}
				error_reporting($this->ebase);
			}
		} else {
			$this->_php_source=$tpl[1];
			if ($sub) {
				$this->etpl=error_reporting();
				error_reporting($this->ebase);
				if ($this->notice) {
					restore_error_handler();
					$this->_include_php();
					set_error_handler('_template_notice_handler');
				} else {
					$this->_include_php();
				}
				error_reporting($this->etpl);
			} else {
				$this->_include_php();
			}
		}
		if (isset($cache)) {
			$cont=ob_get_contents();
			ob_end_flush();
			$this->_make_dir($cache['path']);
			$fp=fopen($cache['path'], 'wb');
			fwrite($fp, strlen($cont).'-'.$cache['cid'].'*'.$cont);
			fclose($fp);
			chmod($cache['path'], $this->permission&~0111);
			if ($cache['rid']) {
				$rdir1=$this->cache_dir.'/%clear/';
				$rdir2=$this->_get_clear_path($cache['cid']);
				if (is_array($cache['rid'])) foreach ($cache['rid'] as $rid) $this->_touch_clear_id($rdir1.$rid.$rdir2);
				else $this->_touch_clear_id($rdir1.$cache['rid'].$rdir2);
			}
			@unlink($cache['lock']);
		} elseif ($this->compile_check==='dev' && $this->caching && @is_dir($this->cache_dir)) {
			if (substr(__file__,0,1)==='/') @shell_exec('rm -rf "'.realpath($this->cache_dir).'/%cache'.$_SERVER['PHP_SELF'].'/"*');
			else @shell_exec('del "'.realpath($this->cache_dir.'/%cache'.$_SERVER['PHP_SELF']).'\\*" /s/q');
		}
	}
	function clearCache()
	{
		if (!$this->caching || !$this->cache_dir || @!is_dir($this->cache_dir)) return;
		$dir=realpath($this->cache_dir);
		if (!func_num_args()) {
			substr(__file__,0,1)==='/' ? @shell_exec('rm -rf "'.$dir.'/"*') : @shell_exec('del "'.$dir.'\\*" /s/q');
		} else {
			if (substr(__file__,0,1)==='/') for ($dir.='/%clear/', $i=0, $s=func_num_args(); $i<$s; $i++) @shell_exec('rm -rf "'.$dir.func_get_arg($i).'/"*');
			else for ($dir.='\\%clear\\', $i=0, $s=func_num_args(); $i<$s; $i++) @shell_exec('del "'.$dir.str_replace('/','\\',func_get_arg($i)).'\\*" /s/q');
		}
	}
	function _get_compile_path($rpath)
	{
		$ext=trim($this->compile_ext) or $ext='php';
		if ($R=strpos($rpath, '?')) {
			$ext=substr($rpath, $R+1).'.'.$ext;
			$rpath=substr($rpath, 0, $R);
		}
		$cpl_base=$this->compile_dir.'/'.($this->skin?$this->skin.'/':'').$rpath;
		$cpl_path=$cpl_base.'.'.$ext;
		if (!$this->compile_check) return $cpl_path;
		$tpl_path=$this->template_dir.'/'.($this->skin?$this->skin.'/':'').$rpath;
		if (@!is_file($tpl_path)) $this->_exit('Error #1', 'cannot find defined template <b>'.$tpl_path.'</b>');
		$tpl_path=realpath($tpl_path);
		$cpl_head='<?php /*Template_2.1.4 '.date('Y/m/d H:i:s', filemtime($tpl_path)).' '.$tpl_path.'*/';
		if ($this->compile_check!=='dev' && @is_file($cpl_path)) {
			$fp=fopen($cpl_path, 'rb');
			$info=fread($fp, strlen($cpl_head));
			fclose($fp);
			if ($info===$cpl_head) return $cpl_path;
		}
		if ($this->_compile($tpl_path, $cpl_base, $cpl_head)) return $cpl_path;
		else exit;
	}
	function _get_clear_path($cid)
	{
		strlen($path=urlencode($_SERVER['PHP_SELF'].'?'.$cid))%128 or $path.='@ff';
		return '/%'.substr(chunk_split($path, 128, '/'), 3, -1);
	}
	function _touch_clear_id($path)
	{
		if (@is_file($path)) return;
		$this->_make_dir($path);
		@touch($path);
		@chmod($path, $this->permission&~0111);
	}
	function _make_dir($path)
	{
		if (@is_dir(dirname($path))) return;
		if (substr(__file__,0,1)!=='/') $path=strtr($path, array('\\\\'=>'/','\\'=>'/'));
		$dirs=explode('/', substr($path, strlen($dir=$this->cache_dir)+1));
		for ($nodir=0,$i=0,$s=count($dirs)-1; $i<$s; $i++) {
			$dir.='/'.$dirs[$i];
			if ($nodir or !@is_dir($dir) and $nodir=1) {
				@mkdir($dir, $this->permission);
				@chmod($dir, $this->permission);
			}
		}
	}
	function _lock_cache($fid, $lock, $dir=0)
	{
		if (substr(__file__,0,1)!=='/') return $this->_is_cached[$fid]=0;
		if ($dir) $this->_make_dir($lock);
		@touch($lock);
		@chmod($lock, $this->permission&~0111);
		$this->_is_cached[$fid]=0;
		return 0;
	}
//
	function define($arg, $path='')
	{
		if ($path) $this->_define($arg, $path);
		else foreach ($arg as $fid => $path) $this->_define($fid, $path);
	}
	function _define($fid, $path)
	{
		switch ($fid[0]) {
		case '!': $this->tpl_[substr($fid,1)]=array('stt', $path); break;
		case '>': $this->tpl_[substr($fid,1)]=array('php', $path); break;
		default : $this->tpl_[$fid]=array('tpl', $path);
		}
	}
	function fetch($fid)
	{
		ob_start();
		$this->print_($fid);
		$fetch = ob_get_contents();
		ob_end_clean();
		return $fetch;
	}
	function setScope($scope='')
	{
		if ($scope) $this->scope_list[$scope]=1;
		$this->scp_=$scope;
	}
	function assign($arg)
	{
		if (is_array($arg)) $var = array_merge($var=&$this->var_[$this->scp_], $arg);
		else $this->var_[$this->scp_][$arg] = func_get_arg(1);
	}
	function loopLoad($id, $n=1)
	{
		if ($n===1) $this->b1= &$this->var_[$this->scp_][$id];
		else $this->{'b'.$n}=&$this->{'b'.--$n}[count($this->{'b'.$n})-1][$id];
	}
	function loopPushAssign($arg, $n=1)
	{
		$this->{'b'.$n}[]=$arg;
	}
	function loopPushLoad($id, $n=2)
	{
		$this->{'b'.$n}=&$this->{'b'.--$n}[][$id];
	}
	function loopAssign($arg, $n=1)
	{
		$section = array_merge($section=&$this->{'b'.$n}[count($this->{'b'.$n})-1], $arg);
	}
	function setLoop($id, $arg, $n=1)
	{
		if ($n===1) $this->var_[$this->scp_][$id] = is_array($arg) ? $arg : array_pad(array(), $arg, 1);
		else $this->{'b'.--$n}[count($this->{'b'.$n})-1][$id] = is_array($arg) ? $arg : array_pad(array(), $arg, 1);
	}
	function pushSetLoop($id, $arg, $n=2)
	{
		$this->{'b'.--$n}[][$id] = is_array($arg) ? $arg : array_pad(array(), $arg, 1);
	}
	function include_()
	{
		if (empty($this->inc_)) $this->inc_=dirname(__file__).'/'.$this->plugin_fld.'/function.';
		foreach (func_get_args() as $F) function_exists($F) or include_once $this->inc_.$F.'.php';
	}
	function getValue($arg)
	{
		return @$this->var_[$this->scp_][$arg];
	}
	function assignRef($arg, &$var) // on ZO, not operate.
	{
		$this->var_[$this->scp_][$arg] = &$var;
	}
	function delete($var)
	{
		unset($this->var_[$this->scp_][$var]);
	}
	function unsetScope($scope='')
	{
		unset($this->scope_list[$scope], $this->var_[$scope]);
	}
	function _read_stpl($path)
	{
		$fp=fopen($path, 'rb');
		echo preg_replace('/^<\?.*?\?>(\r\n|\n|\r)?/s', '', fread($fp, filesize($path)));
		fclose($fp);
	}
	function _include_tpl($TPL_CPL, $TPL_SCP)
	{
		$TPL_VAR = &$this->var_[$TPL_SCP];
		if (false===include $TPL_CPL) exit;
	}
	function _include_php()
	{
		if (false===include $this->_php_source) exit;
	}
	function _compile($tpl_path, $cpl_base, $cpl_head)
	{
		include_once $this->dir_.'Template_.compiler.php';
		$compiler=new Template_Compiler_;
		return $compiler->_compile_template($this, $tpl_path, $cpl_base, $cpl_head);
	}
	function _exit($type, $msg)
	{
		exit("<br />\n".'<span style="font:12px tahoma,arial;color:#DA0000;background:white">Template_ '.$type.': '.$msg."</span><br />\n");
	}
}
function _template_notice_handler($type, $msg, $file, $line)
{
	$msg.=" in <b>$file</b> on line <b>$line</b>";
	switch ($type) {
	case E_NOTICE      :$msg='<span style="font:12px tahoma,arial;color:green;background:white">Template_ Notice #1: '.$msg.'</span>';break;
	case E_WARNING     :
	case E_USER_WARNING:$msg='<b>Warning</b>: '.$msg; break;
	case E_USER_NOTICE :$msg='<b>Notice</b>: ' .$msg; break;
	case E_USER_ERROR  :$msg='<b>Fatal</b>: '  .$msg; break;
	default            :$msg='<b>Unknown</b>: '.$msg; break;
	}
	echo "<br />\n".$msg."<br />\n";
}
?>
