<?php

/* TEMPLATE_ PREFILTER (2003-12-13) */

function adjustPath($source, &$tpl, $indicator='', $type='absolute')
{

//
	$default_indicator = 'css,js,gif,jpg,jpeg,png,swf';
	$path_filter = array();
//


	if (!$indicator || $indicator==='default') $indicator=$default_indicator;
	if (!$indicator=str_replace(',', '|', preg_replace('/^,\s*|\s*,$/', '', $indicator))) return $source;

	$web_path=$_SERVER['PHP_SELF'];
	$tpl_path=$tpl->tpl_path;
	if (!empty($_SERVER['SCRIPT_FILENAME'])) {
		$php_path=$_SERVER['SCRIPT_FILENAME'];
	} elseif (!empty($_SERVER['PATH_TRANSLATED'])) {
		$php_path=$_SERVER['PATH_TRANSLATED'];
	} else {
		$tpl->report('Error #18', 'prefilter "adjustPath" cannot find absolute path of <b>'.$_SERVER['PHP_SELF'].'on OS</b>', true);
		exit;
	}
	$on_ms = $tpl->on_ms;
	$m=array();
	if ($on_ms) {
		$web_path=strtr($web_path, array('\\\\'=>'/','\\'=>'/'));
		$php_path=strtr($php_path, array('\\\\'=>'/','\\'=>'/'));
		$tpl_path=strtr($tpl_path, array('\\\\'=>'/','\\'=>'/'));
	}
	$web_dirs=explode('/', $web_path);
	$php_dirs=explode('/', $php_path);
	$tpl_dirs=explode('/', $tpl_path);
	array_pop($web_dirs);
	array_pop($php_dirs);
	array_pop($tpl_dirs);
	$web_depth=count($web_dirs);
	$php_depth=count($php_dirs);
	$tpl_depth=count($tpl_dirs);

//
	$Dot='(?<=url\()\\\\*\./(?:(?:[^)/]+/)*[^)/]+)?'.
		'|(?<=")\\\\*\./(?:(?:[^"/]+/)*[^"/]+)?'.
		"|(?<=')\\\\*\./(?:(?:[^'/]+/)*[^'/]+)?";
	$Ext= $indicator[0]==='.' ? substr($indicator,2) : $indicator;
	$Ext='(?<=url\()(?:[^"\')/]+/)*[^"\')/]+\.(?:'.$Ext.')(?=\))'.
		'|(?<=")(?:[^"/]+/)*[^"/]+\.(?:'.$Ext.')(?=")'.
		"|(?<=')(?:[^'/]+/)*[^'/]+\.(?:".$Ext.")(?=')".
		'|(?<=\\\\")(?:[^"/]+/)*[^"/]+\.(?:'.$Ext.')(?=\\\\")'.
		"|(?<=\\\\')(?:[^'/]+/)*[^'/]+\.(?:".$Ext.")(?=\\\\')";
	if ($indicator==='.') $pattern=$Dot;
	else $pattern= $indicator[0]==='.' ? $Ext.'|'.$Dot : $Ext;
	$pattern='@('.$pattern.')@ix';
	$split=preg_split($pattern, $source, -1, PREG_SPLIT_DELIM_CAPTURE);

// to relative path

	if ($type==='relative') {
		$less_depth=$php_depth<$tpl_depth ? $php_depth : $tpl_depth;
		for ($i=0; $i<$less_depth; $i++) {
			if ($php_dirs[$i]!=$tpl_dirs[$i]) break;
		}
		$rel_path_pfx = $php_depth>$i ? str_repeat('../',$php_depth-$i) : '';
		if ($tpl_depth>$i) {
			$reducible = $tpl_depth - $i;
			$rel_path_pfx.=implode('/',array_slice($tpl_dirs, $i)).'/';
		} else {
			$reducible = 0;
		}
		for ($i=1,$s=count($split); $i<$s; $i+=2) {
			if (substr($split[$i], 0, 1)==='\\') {
				$split[$i]=substr($split[$i],1);
				continue;
			}
			$split[$i] = preg_replace('@^(\./)+@','',$split[$i]);
			if ($reducible && preg_match('@^((?:\.{2}/)+)@', $split[$i], $m)) {
				$reduce = substr_count($m[1], '../');
				if ($reduce > $reducible) $reduce = $reducible;
				$split[$i] = preg_replace('@(?:[^/]+/){'.$reduce.'}$@', '', $rel_path_pfx) . preg_replace('@^(\.{2}/){'.$reduce.'}@','',$split[$i]);
			} else {
				$split[$i] = $rel_path_pfx . $split[$i];
			}
		}
		return implode('', $split);
	}
	
// to absolute path

	$path_search =array_keys($path_filter);
	$path_replace=array_values($path_filter);
	if ($web_depth===1) {
		$base_path=implode('/', $php_dirs);
	} else {
		$less_depth=($web_depth<$php_depth ? $web_depth : $php_depth)-1;
		$web_test=array_reverse($web_dirs);
		$php_test=array_reverse($php_dirs);
		for ($i=0; $i<$less_depth; $i++) {
			if ($web_test[$i]!=$php_test[$i]) break;
		}
		$base_path=implode('/', array_slice($php_dirs, 0, -$i));
		if ($i<$web_depth-1) {
			array_unshift($path_search, '/^/');
			array_unshift($path_replace, implode('/', array_slice($web_dirs, 0, -$i)));
		}
	}
	$base_length =strlen($base_path);
	$abs_path_pfx=preg_replace('@[^/]+$@', '', $tpl_path);
	for ($i=1,$s=count($split); $i<$s; $i+=2) {
		if (substr($split[$i], 0, 1)==='\\') {
			$split[$i]=substr($split[$i],1);
			continue;
		}
		if (!$src=realpath($abs_path_pfx.$split[$i])) {
			if (preg_match('@^((?:\.{1,2}/)+)@', $split[$i], $m)) {
				$src=preg_replace('@(?:[^/]+/){'.substr_count($m[1],'../').'}$@', '', $abs_path_pfx)
					.preg_replace('@^(\.{1,2}/)+@','',$split[$i]);
			} else {
				$src=$abs_path_pfx . $split[$i];
			}
		}
		if ($on_ms) $src = str_replace('\\','/',$src);
		$split[$i]=substr($src, $base_length);
		if ($path_search) $split[$i]=preg_replace($path_search, $path_replace, $split[$i]);
	}
	return implode('', $split);
}
?>